#include <bits/stdc++.h>

typedef long long ll;
typedef long double ld;

#define P pair
#define Pll P<ll,ll>

#define pb push_back
#define all(a) a.begin(), a.end()
#define len(a) (ll)(a.size())
using namespace std;

ll GetRand(){
    return (rand() << 16) ^ rand();
}
ll StupidSolve(string a1, string b1, string c1){
//    string a1, b1, c1;

//    cin >> a1;
//    cin >> b1;
//    cin >> c1;

    vector < int > a(len(a1)), b(len(b1)), c(len(c1));
    for(int i = 0; i < len(a1); ++i)
        a[i] = a1[i]-'0';
    for(int i = 0; i < len(a1); ++i)
        b[i] = b1[i]-'0';
    for(int i = 0; i < len(a1); ++i)
        c[i] = c1[i]-'0';

    vector < int > id(len(a));
    for(int i = 0; i < len(a); ++i)
        id[i] = i;

    ll cnt = 0;
    do{
        bool flag = true;
        if(a[id[0]] == 0 || b[id[0]] == 0 || c[id[0]] == 0){
            flag = false;
            continue;
        }

        ll a2, b2, c2;
        a2 = 0, b2 = 0, c2 = 0;
        for(int i = 0; i < len(a); ++i)
            a2 = a2*10 + a[id[i]];

        for(int i = 0; i < len(a); ++i)
            b2 = b2*10 + b[id[i]];

        for(int i = 0; i < len(a); ++i)
            c2 = c2*10 + c[id[i]];

        if(a2 + b2 != c2)
            flag = false;
        else{
//            cout << a2 << " + " << b2 << " = " << c2 << endl;
            cnt += flag;
        }
    }while(next_permutation(all(id)));
    return cnt;
}

struct node{
    ll f, s, c;
    node(){}
    node(ll _f, ll _s, ll _c){
        f = _f;
        s = _s;
        c = _c;
    }
};

vector < vector < ll > > graph;
//vector < bool > used;

ll dfs(ll node, vector < bool > used){
    used[node] = true;

    ll cnt = 1;
    ll ans = 0;
    for(auto to : graph[node]){
        if(used[to])continue;
        ans += dfs(to, used);
    }

    for(auto to : used)
        cnt &= to;
    used[node] = false;
    return cnt + ans;
}

ll solve(string a1, string b1, string c1){
    graph.assign(len(a1), {});
//    used.assign(len(a1), 0);
    vector < int > a(len(a1)), b(len(b1)), c(len(c1));
    for(int i = 0; i < len(a1); ++i) {
        a[i] = a1[i]-'0';
    }
    for(int i = 0; i < len(a1); ++i) {
        b[i] = b1[i]-'0';
    }
    for(int i = 0; i < len(a1); ++i) {
        c[i] = c1[i]-'0';
    }

    ll cnt = 0;

    vector < node > r(len(a1));

    for(int i = 0; i < len(a1); ++i){
        if(c[i] - a[i] - b[i] > 1){
            return 0;
        }
    }

    for(int i = 0; i < len(r); ++i){
        ll x = (a[i] + b[i]);
        r[i] = node(x/10, x%10, c[i]);
        if(c[i] == 0 and x == 9) {
            r[i] = node(1, x, c[i]);
        }
    }

    ll n = len(a);
    vector < set < ll > > graph2(n);
    for(int i = 0; i < n; ++i){
        for(int j = 0; j < n; ++j){
            if(i == j)continue;
            if(r[i].s == c[i]){
                if(r[j].f == 0)
                    graph[i].pb(j);
            }else{
                if(r[j].f == 1)
                    graph[i].pb(j);
            }
        }
    }

//    for(int i = 0; i < n; ++i){
//        cout << "vertex" << i << ": ";
//        for(auto to : graph[i])
//            cout << to << ' ';
//        cout << endl;
//    }

    for(int i = 0; i < n; ++i){
        if(a[i] != 0 and b[i] != 0 and c[i] != 0 and r[i].f == 0){
            vector < bool > used(n, 0);
            ll ans = dfs(i, used);
//            cout << ans << endl;
            cnt = (cnt+ans+1000000007)%1000000007;
        }
    }
    return cnt;
}

ll num(string s){
    ll ans = 0;
    for(auto c : s)
        ans = ans * 10 + c - '0';
    return ans;
}
int main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
//    freopen("output.txt", "w", stdout);
    string a, b, c;
    cin >> a >> b >> c;
    if(len(a) < 10)
        cout << StupidSolve(a, b, c);
    else
        cout << solve(a, b, c);
    return 0;
}